'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (_ref) {
  var t = _ref.types;

  return {
    visitor: {
      ExportDefaultDeclaration: function ExportDefaultDeclaration(path) {
        var visitee = path.node.declaration;


        if (!t.isCallExpression(visitee)) {
          return;
        }

        var callee = visitee.callee,
            componentNode = visitee.arguments;


        if (!t.isCallExpression(callee)) {
          return;
        }

        var compose = callee.callee,
            args = callee.arguments;

        args.reverse();

        var lastValID = path.scope.generateUidIdentifier('decomposed');
        var declarator = t.variableDeclarator(lastValID, componentNode[0]);
        var declaration = t.variableDeclaration('const', [declarator]);
        var nodes = [declaration];

        for (var i = 0; i < args.length; i++) {
          // compose func
          var funcID = path.scope.generateUidIdentifier('decomposed');
          declarator = t.variableDeclarator(funcID, args[i]);
          declaration = t.variableDeclaration('const', [declarator]);

          // push func
          nodes.push(declaration);

          // compose val
          var temp = t.callExpression(funcID, [lastValID]);
          lastValID = path.scope.generateUidIdentifier('decomposed');
          declarator = t.variableDeclarator(lastValID, temp);
          declaration = t.variableDeclaration('const', [declarator]);

          // push val
          nodes.push(declaration);
        }

        nodes.push(t.exportDefaultDeclaration(lastValID));

        path.replaceWithMultiple(nodes);
      }
    }
  };
};